// Game "Yummy"
// Jianrong Huang
//6/25/2000

// DirectInput keyboard demo

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  
#define INITGUID


#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>     // directX includes
#include <dinput.h>
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicf.h>
#include "t3dlib3.h" 
#include "Gpdumb1.h"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINXCLASS"  // class name

#define WINDOW_WIDTH    640   // size of window
#define WINDOW_HEIGHT   480

// skelaton directions
#define SKELATON_EAST         0
#define SKELATON_NEAST        1  
#define SKELATON_NORTH        2
#define SKELATON_NWEST        3
#define SKELATON_WEST         4
#define SKELATON_SWEST        5
#define SKELATON_SOUTH        6
#define SKELATON_SEAST        7
//#define DSBCAPS_CTRLDEFAULT  0x000000E0

// asteroid field defines
#define MAX_ROCKS          20
#define ROCK_STATE_OFF     0   // this rock is dead or off
#define ROCK_STATE_ON      1   // this one is alive and in flight

#define ROCK_LARGE         0   // sizes of rock
#define ROCK_MEDIUM        1
#define ROCK_SMALL         2

// defines for player states
#define PLAYER_STATE_DEAD     0
#define PLAYER_STATE_DYING    1
#define PLAYER_STATE_ALIVE    2 

//define for the main loop
#define GAME_STATE_INIT    0
// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL);
int Game_Shutdown(void *parms=NULL);
int Game_Main(void *parms=NULL);
int Switch_Level(void *parms=NULL);
int Switch_Level(int);

// GLOBALS ////////////////////////////////////////////////

HWND main_window_handle = NULL; // save the window handle
HINSTANCE main_instance = NULL; // save the instance
char buffer[80];                // used to print text
int screen_seq;					// screen sequence on a level
int player_hit = 0;				// The strength of the can man
int player_hits = 0;			// The life of cat
int player_limit = 100;			// The limit of the strength
int acc =1;                   // The factor if rock spped

// directinput globals
LPDIRECTINPUT        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE  lpdikey   = NULL;    // dinput keyboard
LPDIRECTINPUTDEVICE  lpdimouse = NULL;    // dinput mouse
LPDIRECTINPUTDEVICE  lpdijoy   = NULL;    // dinput joystick 
LPDIRECTINPUTDEVICE2 lpdijoy2  = NULL;    // dinput joystick
GUID                 joystickGUID;        // guid for main joystick
char                 joyname[80];         // name of joystick

// these contain the target records for all di input packets
UCHAR keyboard_state[256]; // contains keyboard state table
DIMOUSESTATE mouse_state;  // contains state of mouse
DIJOYSTATE joy_state;      // contains state of joystick

// demo globals
BOB          skelaton;     // the player skelaton

BOB rocks[MAX_ROCKS];      // the asteroids

BITMAP_IMAGE background_bmp; // used to hold backgrounds

int rock_sizes[3] = {32,32,32}; // width X height sizes for scaler

// player state variables
int player_state = PLAYER_STATE_ALIVE;
int player_score = 0;  // the score
int player_ships = 5;  // ships left
int player_damage = 0; // damage of player

// animation sequences for bob
int skelaton_anims[8][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
                             {0+12,1+12,0+12,2+12},
                             {0+16,1+16,0+16,2+16},
                             {0+20,1+20,0+20,2+20},
                             {0+24,1+24,0+24,2+24},
                             {0+28,1+28,0+28,2+28}, };


BITMAP_IMAGE reactor;      // the background   

// helper functions for game logic
void Draw_Info(void);
void Draw_Rocks(void);
void Start_Rock(int x, int y, int size,int xv, int yv);
void Move_Rocks(void);
void Delete_Rocks(void);
void Init_Rocks(void);
int Collision_Test(int x1, int y1, int w1, int h1, 
                   int x2, int y2, int w2, int h2);

void Do_Intro(void);

//sound id's
int intro_music_id=-1,
	main_music_id=-1,
	ready_id=-1,
	start_id=-1,
	scream_id=-1,
	game_over_id=-1,
	main_menu_id=-1,
	beep0_id=-1,
	beep1_id=-1,
	beep2_id=-1;
int game_state = GAME_STATE_INIT; //Initial game state

// PROTOTYPES //////////////////////////////////////////////

int Color_Scan(int x1, int y1, int x2, int y2, 
      UCHAR scan_color, UCHAR *scan_buffer, int scan_lpitch);

// FUNCTIONS //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT	ps;		   // used in WM_PAINT
HDC			hdc;	   // handle to a device context

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
		return(0);
		} break;

    case WM_PAINT:
         {
         // start painting
         hdc = BeginPaint(hwnd,&ps);

         // end painting
         EndPaint(hwnd,&ps);
         return(0);
        } break;

	case WM_DESTROY: 
		{
		// kill the application			
		PostQuitMessage(0);
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

// this is the winmain function

WNDCLASS winclass;	// this will hold the class we create
HWND	 hwnd;		// generic window handle
MSG		 msg;		// generic message
HDC      hdc;       // generic dc
PAINTSTRUCT ps;     // generic paintstruct

// first fill in the window class stucture
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL; 
winclass.lpszClassName	= WINDOW_CLASS_NAME;

// register the window class
RegisterClass(&winclass);
	

// create the window, note the use of WS_POPUP
hwnd = CreateWindow(WINDOW_CLASS_NAME, // class
						  "WinX Game Console",	 // title
						  WS_POPUP | WS_VISIBLE,
					 	  0,0,	   // x,y
						  WINDOW_WIDTH,  // width
                          WINDOW_HEIGHT, // height
						  NULL,	   // handle to parent 
						  NULL,	   // handle to menu
						  hinstance,// instance
						  NULL);	// creation parms
//return(0);

// save the window handle and instance in a global
main_window_handle = hwnd;
main_instance      = hinstance;

int first = 0;
ShowWindow(hwnd,ncmdshow);
UpdateWindow(hwnd);
// perform all game console specific initialization
Game_Init();


// enter main event loop
while(1)
	{
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
		// test if this is a quit
        if (msg.message == WM_QUIT)
           break;
	
		// translate any accelerator keys
		TranslateMessage(&msg);

		// send the message to the window proc
		DispatchMessage(&msg);
		} // end if

    // main game processing goes here
	if (player_score < 300)
		acc = 1;
	else 
		if (player_score < 600)
		{ if (acc == 1) player_hits = 0;	// resign Life as full life
			acc = 2;						// Increse the play level
		}
		else 
			if (player_score <900)
			{	if (acc ==2) player_hits =0;	// resign Life as full life
				acc =3;							// Increse the play level
			}
			else
				if (player_score <1200)
				{	if (acc == 3) player_hits = 0;	// resign Life as full life
					acc = 4;						// Increse the play level
				}
				else
				{	if (acc == 4) player_hit = 0;	// resign Life as full life
					acc = 5;						// Increse the play level
				}
    Game_Main();

	} // end while

// shutdown game and release all resources
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

///////////////////////////////////////////////////////////

int Color_Scan(int x1, int y1, int x2, int y2, 
               UCHAR scan_color, UCHAR *scan_buffer, int scan_lpitch)
{
    
if (x1 >= SCREEN_WIDTH)
   x1=SCREEN_WIDTH-1;
else
if (x1 < 0)
   x1=0;

if (x2 >= SCREEN_WIDTH)
   x2=SCREEN_WIDTH-1;
else
if (x2 < 0)
   x2=0;

// now y-coords
if (y1 >= SCREEN_HEIGHT)
   y1=SCREEN_HEIGHT-1;
else
if (y1 < 0)
   y1=0;

if (y2 >= SCREEN_HEIGHT)
   y2=SCREEN_HEIGHT-1;
else
if (y2 < 0)
   y2=0;

// scan the region
scan_buffer +=y1*scan_lpitch;

for (int scan_y=y1; scan_y<=y2; scan_y++)
    {
    for (int scan_x=x1; scan_x<=x2; scan_x++)
        {
        if (scan_buffer[scan_x] == scan_color)
            return(1);
        } // end for x

    // move down a line
    scan_buffer+=scan_lpitch;

    } // end for y

// return failure
return(0);

} // end Color_Scan

///////////////////////////////////////////////////////////

int Load_Sound_Music(void)
{
// this function loads all the sounds and music

// load in intro music
if ((intro_music_id = DSound_Load_WAV("INTRO.WAV"))==-1)
   return(0);
    
// load the main music
//if ((main_music_id = DSound_Load_WAV("STARSNG.WAV"))==-1)
//   return(0);

// load get ready
//if ((ready_id = DSound_Load_WAV("OUTSOUND/ENTERING1.WAV"))==-1)
 //  return(0);

// load engines
if ((start_id = DSound_Load_WAV("START.WAV"))==-1)
   return(0);

// load start
//if ((start_id = DSound_Load_WAV("OUTSOUND/start.WAV"))==-1)
  // return(0);

// load game over
if ((game_over_id = DSound_Load_WAV("GAMEOVER.WAV"))==-1)
   return(0);

if ((beep0_id = DSound_Load_WAV("BEEP0.WAV"))==-1)
   return(0);

if ((beep1_id = DSound_Load_WAV("BEEP1.WAV"))==-1)
   return(0);

if ((beep2_id = DSound_Load_WAV("BEEP2.WAV"))==-1)
   return(0);

return (1);
} //end Load_Sound_Music.



// WINX GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// initialize directdraw
DD_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);

// keyboard creation section ////////////////////////////////

// first create the direct input object
if (DirectInputCreate(main_instance,DIRECTINPUT_VERSION,&lpdi,NULL)!=DI_OK)
   return(0);

// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDevice(GUID_SysKeyboard, &lpdikey, NULL)!=DI_OK)
   return(0);

// set cooperation level
if (lpdikey->SetCooperativeLevel(main_window_handle, 
                 DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)!=DI_OK)
    return(0);

// set data format
if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
   return(0);

// acquire the keyboard
if (lpdikey->Acquire()!=DI_OK)
   return(0);

// hide the mouse
ShowCursor(FALSE);


///////////////////////////////////////////////////////////
// Runs the Intro
// start the intro music

// initialize directsound
DSound_Init();

// load all the sound and music
Load_Sound_Music();

DSound_Play(start_id);

Do_Intro();
// load background image

// load the background

Load_Bitmap_File(&bitmap8bit, "1BACK1.BMP");
// create and load the reactor bitmap image
Create_Bitmap(&reactor, 0,0, 640, 480);
Load_Image_Bitmap(&reactor,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
// set the palette to background image palette
Set_Palette(bitmap8bit.palette);
Unload_Bitmap_File(&bitmap8bit);

// now let's load in all the frames for the skelaton!!!

// create skelaton bob
if (!Create_BOB(&skelaton,0,0,56,72,32,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load the frames in 8 directions, 4 frames each
// each set of frames has a walk and a fire, frame sets
// are loaded in counter clockwise order looking down
// from a birds eys view or the x-z plane
for (int direction = 0; direction < 8; direction++)
    { 
    // build up file name
    sprintf(filename,"SKELSP%d.BMP",direction);

    // load in new bitmap file
    Load_Bitmap_File(&bitmap8bit,filename);

    Load_Frame_BOB(&skelaton,&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&skelaton,&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  

    // unload the bitmap file
    Unload_Bitmap_File(&bitmap8bit);

    // set the animation sequences for skelaton
    Load_Animation_BOB(&skelaton,direction,4,skelaton_anims[direction]);

    } // end for direction

// set up stating state of skelaton
Set_Animation_BOB(&skelaton, 0);
Set_Anim_Speed_BOB(&skelaton, 4);
Set_Vel_BOB(&skelaton, 0,0);
Set_Pos_BOB(&skelaton, 0, 128);

// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height};
lpddclipper = DD_Attach_Clipper(lpddsback,1,&screen_rect);


// init rocks
Init_Rocks();

// initialize directsound
//DSound_Init();

// load all the sound and music
//Load_Sound_Music();

// hide the mouse
ShowCursor(FALSE);

// start the intro music
DSound_Play(intro_music_id,DSBPLAY_LOOPING);



// Puts the character at the bottom of the screen
skelaton.y = 400;
skelaton.x = 200;

// First screen on the level
screen_seq = 1;

// return success
return(1);

} // end Game_Init


///////////////////////////////////////////////////////////

int Collision_Test(int x1, int y1, int w1, int h1, 
                   int x2, int y2, int w2, int h2) 
{
// this function tests if the two rects overlap

// get the radi of each rect
int width1  = (w1>>1) - (w1>>3);
int height1 = (h1>>1) - (h1>>3);

int width2  = (w2>>1) - (w2>>3);
int height2 = (h2>>1) - (h2>>3);

// compute center of each rect
int cx1 = x1 + width1;
int cy1 = y1 + height1;

int cx2 = x2 + width2;
int cy2 = y2 + height2;

// compute deltas
int dx = abs(cx2 - cx1);
int dy = abs(cy2 - cy1);

// test if rects overlap
if (dx < (width1+width2) && dy < (height1+height2))
   return(1);
else
// else no collision
return(0);

} // end Collision_Test


///////////////////////////////////////////////////////////

void Init_Rocks(void)
{
// this function initializes and loads all the rocks 

// load the white imagery 
Load_Bitmap_File(&bitmap8bit, "WMICE.BMP");
Set_Palette(bitmap8bit.palette);
// create the first bob
Create_BOB(&rocks[0],0,0,96,96,20,
            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,
            DDSCAPS_SYSTEMMEMORY);

// load animation frames
for (int frame=0; frame < 20; frame++)
     Load_Frame_BOB(&rocks[0],&bitmap8bit,frame,frame%6,frame/6,BITMAP_EXTRACT_MODE_CELL);  

// set animation rate
//Set_Anim_Speed_BOB(&rocks[0],1+rand()%5);
Set_Anim_Speed_BOB(&rocks[0],2);
//Set_Vel_BOB(&rocks[0], 1+rand()%4, 4+rand()%4);
Set_Vel_BOB(&rocks[0], acc*(-2+rand()%4), acc*(-2+rand()%4));
Set_Pos_BOB(&rocks[0], rand()%SCREEN_WIDTH, rand()%SCREEN_HEIGHT);

// set size of rock
rocks[0].varsI[0] = 0;
rocks[0].varsI[1] = rock_sizes[1];

// set state to off
rocks[0].state = ROCK_STATE_OFF;
Unload_Bitmap_File(&bitmap8bit);

// load the gray mice imagery 
Load_Bitmap_File(&bitmap8bit, "GMICE.BMP");
Set_Palette(bitmap8bit.palette);
// create the first bob
Create_BOB(&rocks[1],0,0,96,96,20,
            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,
            DDSCAPS_SYSTEMMEMORY);

// load animation frames
for ( frame=0; frame < 20; frame++)
     Load_Frame_BOB(&rocks[1],&bitmap8bit,frame,frame%6,frame/6,BITMAP_EXTRACT_MODE_CELL);  

// set animation rate
//Set_Anim_Speed_BOB(&rocks[0],1+rand()%5);
Set_Anim_Speed_BOB(&rocks[1],2);
//Set_Vel_BOB(&rocks[0], -4+rand()%8, -2+rand()%2);
Set_Vel_BOB(&rocks[1], acc*(1+rand()%4), acc*(2+rand()%4));
Set_Pos_BOB(&rocks[1], rand()%SCREEN_WIDTH, rand()%SCREEN_HEIGHT);

// set size of rock
rocks[1].varsI[0] = 1;
rocks[1].varsI[1] = rock_sizes[1];

// set state to off
rocks[1].state = ROCK_STATE_OFF;
Unload_Bitmap_File(&bitmap8bit);

// load the red tail mice imagery 
Load_Bitmap_File(&bitmap8bit, "RED.BMP");
Set_Palette(bitmap8bit.palette);
// create the first bob
Create_BOB(&rocks[2],0,0,96,96,20,
            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,
            DDSCAPS_SYSTEMMEMORY);

// load animation frames
for ( frame=0; frame < 20; frame++)
     Load_Frame_BOB(&rocks[2],&bitmap8bit,frame,frame%6,frame/6,BITMAP_EXTRACT_MODE_CELL);  

// set animation rate
//Set_Anim_Speed_BOB(&rocks[0],1+rand()%5);
Set_Anim_Speed_BOB(&rocks[1],2);
//Set_Vel_BOB(&rocks[2], -4+rand()%8, -4+rand()%8);
Set_Vel_BOB(&rocks[2], acc*(-4+rand()%4), acc*(4+rand()%8));
Set_Pos_BOB(&rocks[2], rand()%SCREEN_WIDTH, rand()%SCREEN_HEIGHT);

// set size of rock
rocks[2].varsI[0] = 2;
rocks[2].varsI[1] = rock_sizes[1];

// set state to off
rocks[1].state = ROCK_STATE_OFF;
Unload_Bitmap_File(&bitmap8bit);

for (int rock=3; rock<MAX_ROCKS-3; rock++)
    {
	if (rock%7==0 || rock%7 == 1)
		memcpy(&rocks[rock], &rocks[1], sizeof(BOB));
	else
        memcpy(&rocks[rock], &rocks[0], sizeof(BOB));

    // set animation rate
    Set_Anim_Speed_BOB(&rocks[rock],1+rand()%5);
    
    // set velocity
    //Set_Vel_BOB(&rocks[rock], -4+rand()%8, 4+rand()%4);
	Set_Vel_BOB(&rocks[rock], acc*(-4+rand()%8), acc*(4+rand()%4));
    
    // set position
    Set_Pos_BOB(&rocks[rock], rand()%SCREEN_WIDTH, rand()%SCREEN_HEIGHT);
    
    // set size of rock
	if (rock%7==0 || rock%7 ==1 )
		rocks[rock].varsI[0] = 1;
	else
		rocks[rock].varsI[0] = 0;
    rocks[rock].varsI[1] = rock_sizes[1];
    } // end for rock
for ( rock=MAX_ROCKS-3; rock<MAX_ROCKS-1; rock++)
    {
	memcpy(&rocks[rock], &rocks[2], sizeof(BOB));
    // set animation rate
    Set_Anim_Speed_BOB(&rocks[rock],1+rand()%5);
    
    // set velocity
    //Set_Vel_BOB(&rocks[rock], -4+rand()%8, 4+rand()%4);
	Set_Vel_BOB(&rocks[rock], acc*(-4+rand()%8), acc*(4+rand()%4));
    
    // set position
    Set_Pos_BOB(&rocks[rock], rand()%SCREEN_WIDTH, rand()%SCREEN_HEIGHT);
    
    // set size of rock
		rocks[rock].varsI[0] = 2;
    rocks[rock].varsI[1] = rock_sizes[1];
    } // end for rock

// unload data infile

} // end Init_Rocks

///////////////////////////////////////////////////////////

void Delete_Rocks(void)
{
// this function simply deletes all memory and surfaces
// related to the rocks pulses

for (int index=0; index<MAX_ROCKS; index++)
    Destroy_BOB(&rocks[index]);

} // end Delete_Rocks

///////////////////////////////////////////////////////////

void Move_Rocks(void)
{
// this function moves all the rocks pulses and checks for
// collision with the rocks
int test;
for (int index=0; index<MAX_ROCKS; index++)
    {
    // test if rocks pulse is in flight
    if (rocks[index].state == ROCK_STATE_ON)
        {
        // move the rock
        Move_BOB(&rocks[index]);

        // test if rock is off screen
        if (rocks[index].y > SCREEN_HEIGHT)
           {
           // kill rock and put back on available list
           rocks[index].state = ROCK_STATE_OFF;
           } // end if
        
        } // end if

	/*	// test if rock is on building 
	
		if (Color_Scan(rocks[index].x+8, rocks[index].y+8,
                  rocks[index].x+rocks[index].width-8, rocks[index].y+rocks[index].height-8,                                    
                  128, back_buffer,back_lpitch))
			{
			// back the skelaton up along its last trajectory
			rocks[index].state = ROCK_STATE_OFF;
			} // end if
	*/

	// test for collision with can man
	if (rocks[index].state == ROCK_STATE_ON)
	{
        if (Collision_Test(skelaton.x, skelaton.y, 
                       skelaton.width, skelaton.height,
                       rocks[index].x, rocks[index].y,
                       rocks[index].varsI[1], rocks[index].varsI[1]))
        {
			// start the music and updata score and life
				rocks[index].state = ROCK_STATE_OFF;
				if (rocks[index].varsI[0]==2) {		// eated red tail mice, Luck
					DSound_Play(beep2_id);
					if (player_hits>=10)
						player_hits=player_hits-10;
					else
						player_score+=30;
				}
				else {
					if (rocks[index].varsI[0]==1){ // eated gray mice, Get score
					   DSound_Play(beep1_id);
				       player_score+=10;
					}
				    else {							// eated white mice, damage life
			     	  	DSound_Play(beep0_id);	
				        player_hits=player_hits+10;
					}

				}
		}
	}

    } // end for index

// now test if it's time to add a new rock to the list 
if (acc==1) test = 6;
if (acc==2) test =5;
if (acc==3) test =4;
if (acc==4) test =2;
if (acc==5) test =1;
if ((rand()%test)==0)
   {
   // scan for a rock to initialize
   for (index=0; index<MAX_ROCKS; index++)
       {
       // is this rock available?
       if (rocks[index].state == ROCK_STATE_OFF)
          {
          // set animation rate
          Set_Anim_Speed_BOB(&rocks[index],1+rand()%5);
    
          // set velocity
		  Set_Vel_BOB(&rocks[index], acc*(-1+rand()%3), acc*(2+rand()%5));
    
          // set position
          Set_Pos_BOB(&rocks[index], rand()%SCREEN_WIDTH, -128);
    
          // turn rock on
          rocks[index].state = ROCK_STATE_ON;
          
          // later
          return;

          } // end if

       } // end for index

   } // end if

} // end Move_Rocks

///////////////////////////////////////////////////////////

void Start_Rock(int x, int y, int size,int xv, int yv)
{
// this functions starts a rock up with the sent parms, considering
// there is one left

// scan for a rock to initialize
   for (int index=0; index<MAX_ROCKS; index++)
       {
       // is this rock available?
       if (rocks[index].state == ROCK_STATE_OFF)
          {
          // set animation rate
          Set_Anim_Speed_BOB(&rocks[index],1+rand()%5);
    
          // set velocity
          Set_Vel_BOB(&rocks[index], xv,yv);
    
          // set position
          Set_Pos_BOB(&rocks[index], x,y);
    
          // set size of rock
          rocks[index].varsI[0] = size;
          rocks[index].varsI[1] = rock_sizes[1];
          

          rocks[index].varsI[2] = 40;

          // turn rock on
          rocks[index].state = ROCK_STATE_ON;
          
          // later
          return;

          } // end if

       } // end for index

} // end Start_Rock

///////////////////////////////////////////////////////////

void Draw_Rocks(void)
{
// this function draws all the rocks 

for (int index=0; index<MAX_ROCKS; index++)
    {
    // test if rocks pulse is in flight
    if (rocks[index].state == ROCK_STATE_ON)
        {

 /*       if (rocks[index].varsI[0]!=ROCK_LARGE)
            {
*/            // draw the rock scaled
            Draw_Scaled_BOB(&rocks[index],
                            rocks[index].varsI[1],rocks[index].varsI[1],
                            lpddsback);
 /*           }
        else // draw normal 
           Draw_BOB(&rocks[index],lpddsback);
         */
        // animate the pulse
        Animate_BOB(&rocks[index]);

        } // end if

    } // end for index

} // end Draw_Rocks

///////////////////////////////////////////////////////////


void Draw_Info(void)
{
// this function draws all the information at the top of the screen

char score[16]; // hold score

// build up scrore string
sprintf(score,"0000000%d",player_score);

// build up final string
sprintf(buffer,"SCORE %s",&score[strlen(score)-8]);
Draw_Text_GDI(buffer,10,10,RGB(0,255,0),lpddsback);

// draw damage
sprintf(buffer,"LIFE %d",player_limit-player_hits);
Draw_Text_GDI(buffer,320-8*strlen(buffer),10,RGB(0,255,0),lpddsback);

// draw ships
sprintf(buffer,"LEVEL %d",acc);
Draw_Text_GDI(buffer,500,10,RGB(0,255,0),lpddsback);

} // end Draw_Info

///////////////////////////////////////////////////////////

void Do_Intro(void)
{
// the worlds simples intro

// DSound_Play(start_id);
DD_Fill_Surface(lpddsback, 0);
DD_Fill_Surface(lpddsprimary, 0);

int shade; // used as looping var


for (shade=0; shade < 256; shade++)
    {
    // draw text in shades
	Draw_Rectangle(40, 40,600, 440,100, lpddsback);
    Draw_Text_GDI("Jianrong Huang Presents...",320-4*strlen("Jianrong Huang Presents..."),200,
                   RGB(shade,shade,shade),lpddsprimary);
    Sleep(50);
    
    // is user trying to bail
    if (KEY_DOWN(VK_ESCAPE))
        return;

    } // end for shade

Sleep(100);

for (shade=255; shade >=0; shade--)
    {
    // draw text in shades
	Draw_Rectangle(40, 40,600, 440,100, lpddsback);
    Draw_Text_GDI("Jianrong Huang Presents...",320-4*strlen("Jianrong Huang Presents..."),200,
                   RGB(0,shade,0),lpddsprimary);
    Sleep(20);
    
    // is user trying to bail
    if (KEY_DOWN(VK_ESCAPE))
        return;

    } // end for shade

Sleep(100);

DD_Fill_Surface(lpddsback, 0);
DD_Fill_Surface(lpddsprimary, 0);

// load bitmap into primary buffer
Load_Bitmap_File(&bitmap8bit, "1back8.BMP");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&background_bmp,0,0,640,480);
Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_CELL);
DD_Lock_Primary_Surface();
Draw_Bitmap(&background_bmp,primary_buffer, primary_lpitch, 0);
DD_Unlock_Primary_Surface();
Unload_Bitmap_File(&bitmap8bit);
Destroy_Bitmap(&background_bmp);

Sleep(9000);

// load bitmap into primary buffer

Load_Bitmap_File(&bitmap8bit, "1back9.BMP");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&background_bmp,0,0,640,480);
Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_CELL);
DD_Lock_Primary_Surface();
Draw_Bitmap(&background_bmp,primary_buffer, primary_lpitch, 0);
DD_Unlock_Primary_Surface();
Unload_Bitmap_File(&bitmap8bit);
Destroy_Bitmap(&background_bmp);

Sleep(10000);

Load_Bitmap_File(&bitmap8bit, "HOWTO.BMP");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&background_bmp,0,0,640,480);
Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_CELL);
DD_Lock_Primary_Surface();
Draw_Bitmap(&background_bmp,primary_buffer, primary_lpitch, 0);
DD_Unlock_Primary_Surface();
Unload_Bitmap_File(&bitmap8bit);
Destroy_Bitmap(&background_bmp);

Sleep(9000);

Load_Bitmap_File(&bitmap8bit, "BLACK.BMP");
Set_Palette(bitmap8bit.palette);
Create_Bitmap(&background_bmp,0,0,640,480);
Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_CELL);
DD_Lock_Primary_Surface();
Draw_Bitmap(&background_bmp,primary_buffer, primary_lpitch, 0);
DD_Unlock_Primary_Surface();
Unload_Bitmap_File(&bitmap8bit);
Destroy_Bitmap(&background_bmp);

Sleep(5);

} // end Do_Intro


// screen is the number of screen sequences in that level
int Switch_Level(int screen)
{

char background[80]; // used to build up files names

// Gets rid of the background
Destroy_Bitmap(&reactor);
	
// Loads the correct background according to the screen
sprintf(background,"1BACK%d.BMP",screen);
Set_Palette(bitmap8bit.palette);

// load the background 2
//Load_Bitmap_File(&bitmap8bit, "1BACK2.BMP");
Load_Bitmap_File(&bitmap8bit, background);
Set_Palette(bitmap8bit.palette);
// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// create and load the reactor bitmap image
Create_Bitmap(&reactor, 0,0, 640, 480);
Load_Image_Bitmap(&reactor,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

// Puts the character back to the bottom or top of the screen
if (screen == 1)
	skelaton.y = 400;
else {
	if (skelaton.y < 200)
		skelaton.y+=400;
	else
		skelaton.y-=400;
}
	
return(1);

}

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// kill skelaton
Destroy_BOB(&skelaton);

// the delete all the rocks
Delete_Rocks();

// release keyboard
lpdikey->Unacquire();
lpdikey->Release();
lpdi->Release();

// shutdonw directdraw
DD_Shutdown();

// unload sounds,
DSound_Delete_All_Sounds();

//shutdown directsound
DSound_Shutdown();

// return success
return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Main(void *parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for your game go here!

int          index;             // looping var
int          dx,dy;             // general deltas used in collision detection
 
static int   player_moving = 0; // tracks player motion

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

DSound_Play(main_music_id, DSBPLAY_LOOPING);

// start the timing clock
Start_Clock();

// clear the drawing surface
DD_Fill_Surface(lpddsback, 0);

// lock the back buffer
DD_Lock_Back_Surface();

// draw the background reactor image
Draw_Bitmap(&reactor, back_buffer, back_lpitch, 0);

// unlock the back buffer
DD_Unlock_Back_Surface();

// get player input

// get the keyboard data
lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);

// reset motion flag
player_moving = 0;

// test direction of motion, this is a good example of testing the keyboard
// although the code could be optimized this is more educational

if (keyboard_state[DIK_RIGHT] && keyboard_state[DIK_UP]) 
   {
   // move skelaton
   skelaton.x+=10+2*acc;
   skelaton.y-=10+2*acc;
   dx=10+2*acc; dy=-10-2*acc;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_NEAST)
      Set_Animation_BOB(&skelaton,SKELATON_NEAST);

   } // end if
else
if (keyboard_state[DIK_LEFT] && keyboard_state[DIK_UP]) 
   {
   // move skelaton with increased spped for every level
   skelaton.x-=10+2*acc;
   skelaton.y-=10+2*acc;
   dx=10-2*acc; dy=10-2*acc;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_NWEST)
      Set_Animation_BOB(&skelaton,SKELATON_NWEST);

   } // end if
else
if (keyboard_state[DIK_LEFT] && keyboard_state[DIK_DOWN]) 
   {
   // move skelaton
   skelaton.x-=10+2*acc;
   skelaton.y+=10+2*acc;
   dx=10-2*acc; dy=10+2*acc;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_SWEST)
      Set_Animation_BOB(&skelaton,SKELATON_SWEST);

   } // end if
else
if (keyboard_state[DIK_RIGHT] && keyboard_state[DIK_DOWN]) 
   {
   // move skelaton
   skelaton.x+=10+2*acc;
   skelaton.y+=10+2*acc;
   dx=10+2*acc; dy=10+2*acc;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_SEAST)
      Set_Animation_BOB(&skelaton,SKELATON_SEAST);

   } // end if
else
if (keyboard_state[DIK_RIGHT]) 
   {
   // move skelaton
   skelaton.x+=10+2*acc;
   dx=10+2*acc; dy=0;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_EAST)
      Set_Animation_BOB(&skelaton,SKELATON_EAST);

   } // end if
else
if (keyboard_state[DIK_LEFT])  
   {
   // move skelaton
   skelaton.x-=10+2*acc;
   dx=10-2*acc; dy=0; 
   
   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_WEST)
      Set_Animation_BOB(&skelaton,SKELATON_WEST);

   } // end if
else
if (keyboard_state[DIK_UP])    
   {
   // move skelaton
   skelaton.y-=10+2*acc;
   dx=0; dy=10-2*acc;
   
   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_NORTH)
      Set_Animation_BOB(&skelaton,SKELATON_NORTH);

   } // end if
else
if (keyboard_state[DIK_DOWN])  
   {
   // move skelaton
   skelaton.y+=6;
   dx=0; dy=+6;

   // set motion flag
   player_moving = 1;

   // check animation needs to change
   if (skelaton.curr_animation != SKELATON_SOUTH)
      Set_Animation_BOB(&skelaton,SKELATON_SOUTH);

   } // end if


if (player_moving)
   {
   // animate skelaton
   Animate_BOB(&skelaton);
   
}


if (player_hits >= player_limit)
	{
//		player_hit=0;
		screen_seq=7;
		Switch_Level(screen_seq);
	}

	  if (screen_seq == 7)
	  {
		  // load bitmap into primary buffer
		  DSound_Play(game_over_id);
		Load_Bitmap_File(&bitmap8bit, "1back7.BMP");
		Set_Palette(bitmap8bit.palette);
		Create_Bitmap(&background_bmp,0,0,640,480);
		Load_Image_Bitmap(&background_bmp, &bitmap8bit,0,0,BITMAP_EXTRACT_MODE_CELL);
		DD_Lock_Primary_Surface();
		Draw_Bitmap(&background_bmp,primary_buffer, primary_lpitch, 0);
		DD_Unlock_Primary_Surface();
		Unload_Bitmap_File(&bitmap8bit);
		Destroy_Bitmap(&background_bmp);

		Sleep(15000);
		Game_Shutdown();
	  }

Draw_BOB(&skelaton, lpddsback);

// move the asteroids
Move_Rocks();

// draw the rocks
Draw_Rocks();

// draw the score and ships left
Draw_Info();

// flip the surfaces
DD_Flip();

// sync to 3o fps
Wait_Clock(30);


// return success

return(1);

} // end Game_Main

//////////////////////////////////////////////////////////